<template>
  <div
    class="container-xxl"
  >
    <div class="row mt-5">
      <div class="col-12 col-md-4 col-lg-5 col-xl-4 mt-2">
        <div
          id="subasta_buscar_formulario"
          class="card card-flush shadow-sm"
        >
          <div class="card-body">
            <div class="d-flex flex-column justify-content-start">
              <div class="d-flex flex-column mt-2">
                <input
                  id="subasta_buscar_input_fecha_min"
                  v-model="mFormulario.fechaMin"
                  type="text"
                  class="form-control"
                  placeholder="Fecha mínima"
                >
              </div>

              <div class="d-flex flex-column mt-2">
                <input
                  id="subasta_buscar_input_fecha_max"
                  v-model="mFormulario.fechaMax"
                  type="text"
                  class="form-control"
                  placeholder="Fecha máxima"
                >
              </div>

              <div class="d-flex flex-column mt-2">
                <button
                  id="subasta_buscar_btn_buscar"
                  class="btn btn-primary"
                  @click="onSubastaBuscar()"
                >
                  <i class="bi bi-search fs-4 me-2" />
                  Buscar
                </button>
              </div>

              <div class="d-flex flex-column mt-2">
                <a
                  class="btn btn-link"
                  data-bs-toggle="collapse"
                  aria-expanded="true"
                  href="#subasta_buscar_opcion_avanzada"
                >Opciones avanzadas
                </a>
              </div>
            </div>

            <div
              id="subasta_buscar_opcion_avanzada"
              class="collapse show"
            >
              <div class="separator separator-dashed mt-9 mb-6" />
              <div class="row g-8 mb-8">
                <div class="col-12">
                  <label class="fs-6 form-label fw-bolder text-dark">Tipo de Moneda</label>
                  <select
                    v-model="mFormulario.tipoMoneda"
                    class="form-select"
                    aria-label="Seleccione una opción"
                  >
                    <option
                      value=""
                      selected
                    >
                      Todos
                    </option>
                    <option
                      value="BOB"
                      selected
                    >
                      BOB
                    </option>
                    <option
                      value="USD"
                      selected
                    >
                      USD
                    </option>
                  </select>
                </div>
              </div>

              <div class="row g-8">
                <div class="col-12 col-xxl-6">
                  <label class="fs-6 form-label fw-bolder text-dark">Precio Min.</label>
                  <input-marcador
                    ref="subastaBuscarInputPrecioMin"
                    identificador="subasta_buscar_input_precio_min"
                    :valor-min="0"
                    :valor-max="500000"
                    :valor-escala="1000"
                    :valor-inicial="0"
                    titulo="Precio mínimo"
                  />
                </div>

                <div class="col-12 col-xxl-6">
                  <label class="fs-6 form-label fw-bolder text-dark">Precio Max.</label>
                  <input-marcador
                    ref="subastaBuscarInputPrecioMax"
                    identificador="subasta_buscar_input_precio_max"
                    :valor-min="0"
                    :valor-max="500000"
                    :valor-escala="1000"
                    :valor-inicial="0"
                    titulo="Precio máximo"
                  />
                </div>

                <div class="col-12 col-xxl-6">
                  <label class="fs-6 form-label fw-bolder text-dark">Peso Min. (Kg)</label>
                  <input-marcador
                    ref="subastaBuscarInputPesoMin"
                    identificador="subasta_buscar_input_peso_min"
                    :valor-min="0"
                    :valor-max="2500"
                    :valor-escala="100"
                    :valor-inicial="0"
                    titulo="Peso mínimo"
                  />
                </div>

                <div class="col-12 col-xxl-6">
                  <label class="fs-6 form-label fw-bolder text-dark">Peso Max. (Kg)</label>
                  <input-marcador
                    ref="subastaBuscarInputPesoMax"
                    identificador="subasta_buscar_input_peso_max"
                    :valor-min="0"
                    :valor-max="2500"
                    :valor-escala="100"
                    :valor-inicial="0"
                    titulo="Peso máximo"
                  />
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="col-12 col-md-8 col-lg-7 col-xl-8 mt-2">
        <mapa-buscar :subastas="subastas" />
      </div>
    </div>
  </div>
</template>
<script>
import MapaBuscar from "@/components/panel/subasta/MapaBuscar";
import InputMarcador from "@/components/util/InputMarcador";

import flatpickr from "flatpickr";
import moment from "moment";
import {Spanish} from "flatpickr/dist/l10n/es";
import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";
import BloqueoUI from "@/core/util/BloqueoUI";

export default {
  name: 'SubastaBuscar',
  components: {
    MapaBuscar, InputMarcador
  },
  data() {
    return {
      mFormulario: {
        fechaMin: '',
        fechaMax: '',
        tipoMoneda: '',
        precioMin: 0,
        precioMax: 0,
        pesoMin: 0,
        pesoMax: 0,
      },
      componentes: {
        bloqueoUI: null,
      },
      subastas: [],
    }
  },

  mounted() {
    flatpickr("#subastaBuscarFechaMin", { "locale": Spanish });
    flatpickr("#subastaBuscarFechaMax", { "locale": Spanish });
    this.componentes.bloqueoUI = new BloqueoUI('#subasta_buscar_formulario', '#subasta_buscar_btn_buscar');

    this.mFormulario.fechaMin = moment().format('yyyy-MM-D');
    this.mFormulario.fechaMax = moment().add(1, 'M').format('yyyy-MM-D');
    this.onSubastaBuscar();
  },
  methods: {

    onSubastaBuscar() {
      this.subastas = [];
      this.mFormulario.precioMin = this.$refs.subastaBuscarInputPrecioMin.getValor();
      this.mFormulario.precioMax = this.$refs.subastaBuscarInputPrecioMax.getValor();
      this.mFormulario.pesoMin = this.$refs.subastaBuscarInputPesoMin.getValor();
      this.mFormulario.pesoMax = this.$refs.subastaBuscarInputPesoMax.getValor();
      this.componentes.bloqueoUI.iniciarBloqueoFormulario();


      Servicio.post(Ruta.PANEL_SUBASTA_BUSCAR, this.mFormulario).then( (data) => {
        this.subastas = data.data;
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
      }).catch( (error) => {
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        Toast.mostrarError(error);
      });
    },
  },

}
</script>